<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head><meta http-equiv="content-type" content="text/html; charset=UTF-8" />
<title>CppClassifierGenerator xref</title>
<link type="text/css" rel="stylesheet" href="../../../../../../../../stylesheet.css" />
</head>
<body>
<div id="overview"><a href="../../../../../../../../../apidocs/org/eclipse/papyrus/designer/languages/cpp/codegen/xtend/CppClassifierGenerator.html">View Javadoc</a></div><pre>
<a class="jxr_linenumber" name="L1" href="#L1">1</a>   <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L2" href="#L2">2</a>   <em class="jxr_javadoccomment"> * Copyright (c) 2014 CEA LIST.</em>
<a class="jxr_linenumber" name="L3" href="#L3">3</a>   <em class="jxr_javadoccomment"> * All rights reserved. This program and the accompanying materials</em>
<a class="jxr_linenumber" name="L4" href="#L4">4</a>   <em class="jxr_javadoccomment"> * are made available under the terms of the Eclipse Public License v1.0</em>
<a class="jxr_linenumber" name="L5" href="#L5">5</a>   <em class="jxr_javadoccomment"> * which accompanies this distribution, and is available at</em>
<a class="jxr_linenumber" name="L6" href="#L6">6</a>   <em class="jxr_javadoccomment"> * <a href="http://www.eclipse.org/legal/epl-v10.htm" target="alexandria_uri">http://www.eclipse.org/legal/epl-v10.htm</a>l</em>
<a class="jxr_linenumber" name="L7" href="#L7">7</a>   <em class="jxr_javadoccomment"> * </em>
<a class="jxr_linenumber" name="L8" href="#L8">8</a>   <em class="jxr_javadoccomment"> * Contributors:</em>
<a class="jxr_linenumber" name="L9" href="#L9">9</a>   <em class="jxr_javadoccomment"> *     CEA LIST - initial API and implementation</em>
<a class="jxr_linenumber" name="L10" href="#L10">10</a>  <em class="jxr_javadoccomment"> */</em>
<a class="jxr_linenumber" name="L11" href="#L11">11</a>  <strong class="jxr_keyword">package</strong> org.eclipse.papyrus.designer.languages.cpp.codegen.xtend;
<a class="jxr_linenumber" name="L12" href="#L12">12</a>  
<a class="jxr_linenumber" name="L13" href="#L13">13</a>  <strong class="jxr_keyword">import</strong> com.google.common.base.Objects;
<a class="jxr_linenumber" name="L14" href="#L14">14</a>  <strong class="jxr_keyword">import</strong> java.util.Collection;
<a class="jxr_linenumber" name="L15" href="#L15">15</a>  <strong class="jxr_keyword">import</strong> java.util.List;
<a class="jxr_linenumber" name="L16" href="#L16">16</a>  <strong class="jxr_keyword">import</strong> org.eclipse.emf.common.util.EList;
<a class="jxr_linenumber" name="L17" href="#L17">17</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.languages.common.base.GenUtils;
<a class="jxr_linenumber" name="L18" href="#L18">18</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.languages.cpp.codegen.preferences.CppCodeGenUtils;
<a class="jxr_linenumber" name="L19" href="#L19">19</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.languages.cpp.codegen.utils.CppGenUtils;
<a class="jxr_linenumber" name="L20" href="#L20">20</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.languages.cpp.codegen.xtend.CppAttribute;
<a class="jxr_linenumber" name="L21" href="#L21">21</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.languages.cpp.codegen.xtend.CppClassAttributesDeclaration;
<a class="jxr_linenumber" name="L22" href="#L22">22</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.languages.cpp.codegen.xtend.CppClassFriendDeclaration;
<a class="jxr_linenumber" name="L23" href="#L23">23</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.languages.cpp.codegen.xtend.CppClassIncludeClassDeclaration;
<a class="jxr_linenumber" name="L24" href="#L24">24</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.languages.cpp.codegen.xtend.CppClassInheritedDeclarations;
<a class="jxr_linenumber" name="L25" href="#L25">25</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.languages.cpp.codegen.xtend.CppClassOperationsDeclaration;
<a class="jxr_linenumber" name="L26" href="#L26">26</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.languages.cpp.codegen.xtend.CppClassOperationsImplementation;
<a class="jxr_linenumber" name="L27" href="#L27">27</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.languages.cpp.codegen.xtend.CppClassTypeAndEnum;
<a class="jxr_linenumber" name="L28" href="#L28">28</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.languages.cpp.codegen.xtend.CppDocumentation;
<a class="jxr_linenumber" name="L29" href="#L29">29</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.languages.cpp.codegen.xtend.CppIncludeUtil;
<a class="jxr_linenumber" name="L30" href="#L30">30</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.languages.cpp.codegen.xtend.CppOperations;
<a class="jxr_linenumber" name="L31" href="#L31">31</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.languages.cpp.codegen.xtend.CppTemplates;
<a class="jxr_linenumber" name="L32" href="#L32">32</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.languages.cpp.profile.C_Cpp.Union;
<a class="jxr_linenumber" name="L33" href="#L33">33</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Classifier;
<a class="jxr_linenumber" name="L34" href="#L34">34</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.DataType;
<a class="jxr_linenumber" name="L35" href="#L35">35</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Element;
<a class="jxr_linenumber" name="L36" href="#L36">36</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.NamedElement;
<a class="jxr_linenumber" name="L37" href="#L37">37</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Operation;
<a class="jxr_linenumber" name="L38" href="#L38">38</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Property;
<a class="jxr_linenumber" name="L39" href="#L39">39</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.TemplateBinding;
<a class="jxr_linenumber" name="L40" href="#L40">40</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.TemplateParameterSubstitution;
<a class="jxr_linenumber" name="L41" href="#L41">41</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.ValueSpecification;
<a class="jxr_linenumber" name="L42" href="#L42">42</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.VisibilityKind;
<a class="jxr_linenumber" name="L43" href="#L43">43</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.profile.standard.Create;
<a class="jxr_linenumber" name="L44" href="#L44">44</a>  <strong class="jxr_keyword">import</strong> org.eclipse.xtend2.lib.StringConcatenation;
<a class="jxr_linenumber" name="L45" href="#L45">45</a>  <strong class="jxr_keyword">import</strong> org.eclipse.xtext.xbase.lib.Functions.Function1;
<a class="jxr_linenumber" name="L46" href="#L46">46</a>  <strong class="jxr_keyword">import</strong> org.eclipse.xtext.xbase.lib.IterableExtensions;
<a class="jxr_linenumber" name="L47" href="#L47">47</a>  
<a class="jxr_linenumber" name="L48" href="#L48">48</a>  <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L49" href="#L49">49</a>  <em class="jxr_javadoccomment"> * @author Ansgar Radermacher (ansgar.radermacher@cea.fr)</em>
<a class="jxr_linenumber" name="L50" href="#L50">50</a>  <em class="jxr_javadoccomment"> */</em>
<a class="jxr_linenumber" name="L51" href="#L51">51</a>  @SuppressWarnings(<span class="jxr_string">"all"</span>)
<a class="jxr_linenumber" name="L52" href="#L52">52</a>  <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">class</strong> <a href="../../../../../../../../org/eclipse/papyrus/designer/languages/cpp/codegen/xtend/CppClassifierGenerator.html">CppClassifierGenerator</a> {
<a class="jxr_linenumber" name="L53" href="#L53">53</a>    <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> CharSequence generateBindHeaderCode(<strong class="jxr_keyword">final</strong> Classifier classifier) {
<a class="jxr_linenumber" name="L54" href="#L54">54</a>      StringConcatenation _builder = <strong class="jxr_keyword">new</strong> StringConcatenation();
<a class="jxr_linenumber" name="L55" href="#L55">55</a>      _builder.append(<span class="jxr_string">"#ifndef "</span>);
<a class="jxr_linenumber" name="L56" href="#L56">56</a>      String _fullNameUC = GenUtils.getFullNameUC(classifier);
<a class="jxr_linenumber" name="L57" href="#L57">57</a>      _builder.append(_fullNameUC, <span class="jxr_string">""</span>);
<a class="jxr_linenumber" name="L58" href="#L58">58</a>      _builder.append(<span class="jxr_string">"_H"</span>);
<a class="jxr_linenumber" name="L59" href="#L59">59</a>      _builder.newLineIfNotEmpty();
<a class="jxr_linenumber" name="L60" href="#L60">60</a>      _builder.append(<span class="jxr_string">"#define "</span>);
<a class="jxr_linenumber" name="L61" href="#L61">61</a>      String _fullNameUC_1 = GenUtils.getFullNameUC(classifier);
<a class="jxr_linenumber" name="L62" href="#L62">62</a>      _builder.append(_fullNameUC_1, <span class="jxr_string">""</span>);
<a class="jxr_linenumber" name="L63" href="#L63">63</a>      _builder.append(<span class="jxr_string">"_H"</span>);
<a class="jxr_linenumber" name="L64" href="#L64">64</a>      _builder.newLineIfNotEmpty();
<a class="jxr_linenumber" name="L65" href="#L65">65</a>      _builder.newLine();
<a class="jxr_linenumber" name="L66" href="#L66">66</a>      _builder.append(<span class="jxr_string">"/************************************************************"</span>);
<a class="jxr_linenumber" name="L67" href="#L67">67</a>      _builder.newLine();
<a class="jxr_linenumber" name="L68" href="#L68">68</a>      _builder.append(<span class="jxr_string">"              "</span>);
<a class="jxr_linenumber" name="L69" href="#L69">69</a>      String _name = classifier.getName();
<a class="jxr_linenumber" name="L70" href="#L70">70</a>      _builder.append(_name, <span class="jxr_string">"              "</span>);
<a class="jxr_linenumber" name="L71" href="#L71">71</a>      _builder.append(<span class="jxr_string">" template binding header"</span>);
<a class="jxr_linenumber" name="L72" href="#L72">72</a>      _builder.newLineIfNotEmpty();
<a class="jxr_linenumber" name="L73" href="#L73">73</a>      _builder.append(<span class="jxr_string">" "</span>);
<a class="jxr_linenumber" name="L74" href="#L74">74</a>      _builder.append(<span class="jxr_string">"************************************************************/"</span>);
<a class="jxr_linenumber" name="L75" href="#L75">75</a>      _builder.newLine();
<a class="jxr_linenumber" name="L76" href="#L76">76</a>      _builder.newLine();
<a class="jxr_linenumber" name="L77" href="#L77">77</a>      org.eclipse.uml2.uml.Package _<strong class="jxr_keyword">package</strong> = classifier.getPackage();
<a class="jxr_linenumber" name="L78" href="#L78">78</a>      String _cppOwnerPackageIncludePath = CppClassIncludeClassDeclaration.cppOwnerPackageIncludePath(_<strong class="jxr_keyword">package</strong>);
<a class="jxr_linenumber" name="L79" href="#L79">79</a>      String _includeDirective = CppIncludeUtil.includeDirective(_cppOwnerPackageIncludePath);
<a class="jxr_linenumber" name="L80" href="#L80">80</a>      _builder.append(_includeDirective, <span class="jxr_string">""</span>);
<a class="jxr_linenumber" name="L81" href="#L81">81</a>      _builder.newLineIfNotEmpty();
<a class="jxr_linenumber" name="L82" href="#L82">82</a>      _builder.newLine();
<a class="jxr_linenumber" name="L83" href="#L83">83</a>      String _CppIncludeHeader = CppIncludeUtil.CppIncludeHeader(classifier);
<a class="jxr_linenumber" name="L84" href="#L84">84</a>      _builder.append(_CppIncludeHeader, <span class="jxr_string">""</span>);
<a class="jxr_linenumber" name="L85" href="#L85">85</a>      _builder.newLineIfNotEmpty();
<a class="jxr_linenumber" name="L86" href="#L86">86</a>      _builder.newLine();
<a class="jxr_linenumber" name="L87" href="#L87">87</a>      TemplateBinding tb = GenUtils.getTemplateBinding(classifier);
<a class="jxr_linenumber" name="L88" href="#L88">88</a>      _builder.newLineIfNotEmpty();
<a class="jxr_linenumber" name="L89" href="#L89">89</a>      EList&lt;Element&gt; _targets = tb.getTargets();
<a class="jxr_linenumber" name="L90" href="#L90">90</a>      Element templateElement = _targets.get(0);
<a class="jxr_linenumber" name="L91" href="#L91">91</a>      _builder.newLineIfNotEmpty();
<a class="jxr_linenumber" name="L92" href="#L92">92</a>      org.eclipse.uml2.uml.Package _<strong class="jxr_keyword">package</strong>_1 = classifier.getPackage();
<a class="jxr_linenumber" name="L93" href="#L93">93</a>      String _fullPath = GenUtils.getFullPath(_<strong class="jxr_keyword">package</strong>_1);
<a class="jxr_linenumber" name="L94" href="#L94">94</a>      String _plus = (_fullPath + <span class="jxr_string">"/"</span>);
<a class="jxr_linenumber" name="L95" href="#L95">95</a>      Element _owner = templateElement.getOwner();
<a class="jxr_linenumber" name="L96" href="#L96">96</a>      String _name_1 = ((NamedElement) _owner).getName();
<a class="jxr_linenumber" name="L97" href="#L97">97</a>      String _plus_1 = (_plus + _name_1);
<a class="jxr_linenumber" name="L98" href="#L98">98</a>      String _plus_2 = (_plus_1 + <span class="jxr_string">"."</span>);
<a class="jxr_linenumber" name="L99" href="#L99">99</a>      String _headerSuffix = CppCodeGenUtils.getHeaderSuffix();
<a class="jxr_linenumber" name="L100" href="#L100">100</a>     String _plus_3 = (_plus_2 + _headerSuffix);
<a class="jxr_linenumber" name="L101" href="#L101">101</a>     String _includeDirective_1 = CppIncludeUtil.includeDirective(_plus_3);
<a class="jxr_linenumber" name="L102" href="#L102">102</a>     _builder.append(_includeDirective_1, <span class="jxr_string">""</span>);
<a class="jxr_linenumber" name="L103" href="#L103">103</a>     _builder.newLineIfNotEmpty();
<a class="jxr_linenumber" name="L104" href="#L104">104</a>     _builder.newLine();
<a class="jxr_linenumber" name="L105" href="#L105">105</a>     {
<a class="jxr_linenumber" name="L106" href="#L106">106</a>       List&lt;String&gt; _sortedDeclarePathList = CppClassifierGenerator.getSortedDeclarePathList(classifier);
<a class="jxr_linenumber" name="L107" href="#L107">107</a>       <strong class="jxr_keyword">for</strong>(<strong class="jxr_keyword">final</strong> String path : _sortedDeclarePathList) {
<a class="jxr_linenumber" name="L108" href="#L108">108</a>         String _declareDirective = CppIncludeUtil.declareDirective(path);
<a class="jxr_linenumber" name="L109" href="#L109">109</a>         _builder.append(_declareDirective, <span class="jxr_string">""</span>);
<a class="jxr_linenumber" name="L110" href="#L110">110</a>         _builder.newLineIfNotEmpty();
<a class="jxr_linenumber" name="L111" href="#L111">111</a>       }
<a class="jxr_linenumber" name="L112" href="#L112">112</a>     }
<a class="jxr_linenumber" name="L113" href="#L113">113</a>     _builder.newLine();
<a class="jxr_linenumber" name="L114" href="#L114">114</a>     String _openNS = CppGenUtils.openNS(classifier);
<a class="jxr_linenumber" name="L115" href="#L115">115</a>     _builder.append(_openNS, <span class="jxr_string">""</span>);
<a class="jxr_linenumber" name="L116" href="#L116">116</a>     _builder.newLineIfNotEmpty();
<a class="jxr_linenumber" name="L117" href="#L117">117</a>     _builder.append(<span class="jxr_string">"/************************************************************/"</span>);
<a class="jxr_linenumber" name="L118" href="#L118">118</a>     _builder.newLine();
<a class="jxr_linenumber" name="L119" href="#L119">119</a>     _builder.append(<span class="jxr_string">"typedef "</span>);
<a class="jxr_linenumber" name="L120" href="#L120">120</a>     Element _owner_1 = templateElement.getOwner();
<a class="jxr_linenumber" name="L121" href="#L121">121</a>     String _name_2 = ((NamedElement) _owner_1).getName();
<a class="jxr_linenumber" name="L122" href="#L122">122</a>     _builder.append(_name_2, <span class="jxr_string">""</span>);
<a class="jxr_linenumber" name="L123" href="#L123">123</a>     _builder.append(<span class="jxr_string">"&lt;"</span>);
<a class="jxr_linenumber" name="L124" href="#L124">124</a>     {
<a class="jxr_linenumber" name="L125" href="#L125">125</a>       EList&lt;TemplateParameterSubstitution&gt; _parameterSubstitutions = tb.getParameterSubstitutions();
<a class="jxr_linenumber" name="L126" href="#L126">126</a>       <strong class="jxr_keyword">boolean</strong> _hasElements = false;
<a class="jxr_linenumber" name="L127" href="#L127">127</a>       <strong class="jxr_keyword">for</strong>(<strong class="jxr_keyword">final</strong> TemplateParameterSubstitution ps : _parameterSubstitutions) {
<a class="jxr_linenumber" name="L128" href="#L128">128</a>         <strong class="jxr_keyword">if</strong> (!_hasElements) {
<a class="jxr_linenumber" name="L129" href="#L129">129</a>           _hasElements = <strong class="jxr_keyword">true</strong>;
<a class="jxr_linenumber" name="L130" href="#L130">130</a>         } <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L131" href="#L131">131</a>           _builder.appendImmediate(<span class="jxr_string">", "</span>, <span class="jxr_string">""</span>);
<a class="jxr_linenumber" name="L132" href="#L132">132</a>         }
<a class="jxr_linenumber" name="L133" href="#L133">133</a>         Object _CppTemplateBindingParameter = CppTemplates.CppTemplateBindingParameter(ps);
<a class="jxr_linenumber" name="L134" href="#L134">134</a>         _builder.append(_CppTemplateBindingParameter, <span class="jxr_string">""</span>);
<a class="jxr_linenumber" name="L135" href="#L135">135</a>       }
<a class="jxr_linenumber" name="L136" href="#L136">136</a>     }
<a class="jxr_linenumber" name="L137" href="#L137">137</a>     _builder.append(<span class="jxr_string">"&gt; "</span>);
<a class="jxr_linenumber" name="L138" href="#L138">138</a>     String _name_3 = classifier.getName();
<a class="jxr_linenumber" name="L139" href="#L139">139</a>     _builder.append(_name_3, <span class="jxr_string">""</span>);
<a class="jxr_linenumber" name="L140" href="#L140">140</a>     _builder.append(<span class="jxr_string">";"</span>);
<a class="jxr_linenumber" name="L141" href="#L141">141</a>     _builder.newLineIfNotEmpty();
<a class="jxr_linenumber" name="L142" href="#L142">142</a>     _builder.newLine();
<a class="jxr_linenumber" name="L143" href="#L143">143</a>     String _closeNS = CppGenUtils.closeNS(classifier);
<a class="jxr_linenumber" name="L144" href="#L144">144</a>     _builder.append(_closeNS, <span class="jxr_string">""</span>);
<a class="jxr_linenumber" name="L145" href="#L145">145</a>     _builder.newLineIfNotEmpty();
<a class="jxr_linenumber" name="L146" href="#L146">146</a>     _builder.newLine();
<a class="jxr_linenumber" name="L147" href="#L147">147</a>     _builder.append(<span class="jxr_string">"/************************************************************"</span>);
<a class="jxr_linenumber" name="L148" href="#L148">148</a>     _builder.newLine();
<a class="jxr_linenumber" name="L149" href="#L149">149</a>     _builder.append(<span class="jxr_string">"              "</span>);
<a class="jxr_linenumber" name="L150" href="#L150">150</a>     _builder.append(<span class="jxr_string">"End of "</span>);
<a class="jxr_linenumber" name="L151" href="#L151">151</a>     String _name_4 = classifier.getName();
<a class="jxr_linenumber" name="L152" href="#L152">152</a>     _builder.append(_name_4, <span class="jxr_string">"              "</span>);
<a class="jxr_linenumber" name="L153" href="#L153">153</a>     _builder.append(<span class="jxr_string">" template binding header"</span>);
<a class="jxr_linenumber" name="L154" href="#L154">154</a>     _builder.newLineIfNotEmpty();
<a class="jxr_linenumber" name="L155" href="#L155">155</a>     _builder.append(<span class="jxr_string">" "</span>);
<a class="jxr_linenumber" name="L156" href="#L156">156</a>     _builder.append(<span class="jxr_string">"************************************************************/"</span>);
<a class="jxr_linenumber" name="L157" href="#L157">157</a>     _builder.newLine();
<a class="jxr_linenumber" name="L158" href="#L158">158</a>     _builder.newLine();
<a class="jxr_linenumber" name="L159" href="#L159">159</a>     _builder.append(<span class="jxr_string">"#endif"</span>);
<a class="jxr_linenumber" name="L160" href="#L160">160</a>     _builder.newLine();
<a class="jxr_linenumber" name="L161" href="#L161">161</a>     <strong class="jxr_keyword">return</strong> _builder;
<a class="jxr_linenumber" name="L162" href="#L162">162</a>   }
<a class="jxr_linenumber" name="L163" href="#L163">163</a>   
<a class="jxr_linenumber" name="L164" href="#L164">164</a>   <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> List&lt;String&gt; getSortedIncludePathList(<strong class="jxr_keyword">final</strong> Classifier classifier) {
<a class="jxr_linenumber" name="L165" href="#L165">165</a>     Iterable&lt;String&gt; _CppClassAllIncludes = CppClassIncludeClassDeclaration.CppClassAllIncludes(classifier);
<a class="jxr_linenumber" name="L166" href="#L166">166</a>     List&lt;String&gt; includePathList = IterableExtensions.&lt;String&gt;sort(_CppClassAllIncludes);
<a class="jxr_linenumber" name="L167" href="#L167">167</a>     <strong class="jxr_keyword">return</strong> includePathList;
<a class="jxr_linenumber" name="L168" href="#L168">168</a>   }
<a class="jxr_linenumber" name="L169" href="#L169">169</a>   
<a class="jxr_linenumber" name="L170" href="#L170">170</a>   <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> List&lt;String&gt; getSortedDeclarePathList(<strong class="jxr_keyword">final</strong> Classifier classifier) {
<a class="jxr_linenumber" name="L171" href="#L171">171</a>     Iterable&lt;String&gt; _CppClassAllDeclares = CppClassIncludeClassDeclaration.CppClassAllDeclares(classifier);
<a class="jxr_linenumber" name="L172" href="#L172">172</a>     List&lt;String&gt; declarePathList = IterableExtensions.&lt;String&gt;sort(_CppClassAllDeclares);
<a class="jxr_linenumber" name="L173" href="#L173">173</a>     <strong class="jxr_keyword">return</strong> declarePathList;
<a class="jxr_linenumber" name="L174" href="#L174">174</a>   }
<a class="jxr_linenumber" name="L175" href="#L175">175</a>   
<a class="jxr_linenumber" name="L176" href="#L176">176</a>   <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> CharSequence generateBindBodyCode(<strong class="jxr_keyword">final</strong> Classifier classifier) {
<a class="jxr_linenumber" name="L177" href="#L177">177</a>     StringConcatenation _builder = <strong class="jxr_keyword">new</strong> StringConcatenation();
<a class="jxr_linenumber" name="L178" href="#L178">178</a>     _builder.append(<span class="jxr_string">"#define "</span>);
<a class="jxr_linenumber" name="L179" href="#L179">179</a>     String _fullNameUC = GenUtils.getFullNameUC(classifier);
<a class="jxr_linenumber" name="L180" href="#L180">180</a>     _builder.append(_fullNameUC, <span class="jxr_string">""</span>);
<a class="jxr_linenumber" name="L181" href="#L181">181</a>     _builder.append(<span class="jxr_string">"_BODY"</span>);
<a class="jxr_linenumber" name="L182" href="#L182">182</a>     _builder.newLineIfNotEmpty();
<a class="jxr_linenumber" name="L183" href="#L183">183</a>     _builder.newLine();
<a class="jxr_linenumber" name="L184" href="#L184">184</a>     _builder.append(<span class="jxr_string">"/************************************************************"</span>);
<a class="jxr_linenumber" name="L185" href="#L185">185</a>     _builder.newLine();
<a class="jxr_linenumber" name="L186" href="#L186">186</a>     _builder.append(<span class="jxr_string">"              "</span>);
<a class="jxr_linenumber" name="L187" href="#L187">187</a>     String _name = classifier.getName();
<a class="jxr_linenumber" name="L188" href="#L188">188</a>     _builder.append(_name, <span class="jxr_string">"              "</span>);
<a class="jxr_linenumber" name="L189" href="#L189">189</a>     _builder.append(<span class="jxr_string">" template binding body"</span>);
<a class="jxr_linenumber" name="L190" href="#L190">190</a>     _builder.newLineIfNotEmpty();
<a class="jxr_linenumber" name="L191" href="#L191">191</a>     _builder.append(<span class="jxr_string">" "</span>);
<a class="jxr_linenumber" name="L192" href="#L192">192</a>     _builder.append(<span class="jxr_string">"************************************************************/"</span>);
<a class="jxr_linenumber" name="L193" href="#L193">193</a>     _builder.newLine();
<a class="jxr_linenumber" name="L194" href="#L194">194</a>     _builder.newLine();
<a class="jxr_linenumber" name="L195" href="#L195">195</a>     String _CppIncludePreBody = CppIncludeUtil.CppIncludePreBody(classifier);
<a class="jxr_linenumber" name="L196" href="#L196">196</a>     _builder.append(_CppIncludePreBody, <span class="jxr_string">""</span>);
<a class="jxr_linenumber" name="L197" href="#L197">197</a>     _builder.newLineIfNotEmpty();
<a class="jxr_linenumber" name="L198" href="#L198">198</a>     _builder.newLine();
<a class="jxr_linenumber" name="L199" href="#L199">199</a>     _builder.append(<span class="jxr_string">"// include associated header file"</span>);
<a class="jxr_linenumber" name="L200" href="#L200">200</a>     _builder.newLine();
<a class="jxr_linenumber" name="L201" href="#L201">201</a>     org.eclipse.uml2.uml.Package _<strong class="jxr_keyword">package</strong> = classifier.getPackage();
<a class="jxr_linenumber" name="L202" href="#L202">202</a>     String _fullPath = GenUtils.getFullPath(_<strong class="jxr_keyword">package</strong>);
<a class="jxr_linenumber" name="L203" href="#L203">203</a>     String _plus = (_fullPath + <span class="jxr_string">"/"</span>);
<a class="jxr_linenumber" name="L204" href="#L204">204</a>     String _name_1 = classifier.getName();
<a class="jxr_linenumber" name="L205" href="#L205">205</a>     String _plus_1 = (_plus + _name_1);
<a class="jxr_linenumber" name="L206" href="#L206">206</a>     String _plus_2 = (_plus_1 + <span class="jxr_string">"."</span>);
<a class="jxr_linenumber" name="L207" href="#L207">207</a>     String _headerSuffix = CppCodeGenUtils.getHeaderSuffix();
<a class="jxr_linenumber" name="L208" href="#L208">208</a>     String _plus_3 = (_plus_2 + _headerSuffix);
<a class="jxr_linenumber" name="L209" href="#L209">209</a>     String _includeDirective = CppIncludeUtil.includeDirective(_plus_3);
<a class="jxr_linenumber" name="L210" href="#L210">210</a>     _builder.append(_includeDirective, <span class="jxr_string">""</span>);
<a class="jxr_linenumber" name="L211" href="#L211">211</a>     _builder.newLineIfNotEmpty();
<a class="jxr_linenumber" name="L212" href="#L212">212</a>     _builder.newLine();
<a class="jxr_linenumber" name="L213" href="#L213">213</a>     _builder.newLine();
<a class="jxr_linenumber" name="L214" href="#L214">214</a>     _builder.append(<span class="jxr_string">"// Derived includes directives"</span>);
<a class="jxr_linenumber" name="L215" href="#L215">215</a>     _builder.newLine();
<a class="jxr_linenumber" name="L216" href="#L216">216</a>     {
<a class="jxr_linenumber" name="L217" href="#L217">217</a>       Iterable&lt;String&gt; _CppClassAllIncludesDeclarationBody = CppClassIncludeClassDeclaration.CppClassAllIncludesDeclarationBody(classifier);
<a class="jxr_linenumber" name="L218" href="#L218">218</a>       List&lt;String&gt; _sort = IterableExtensions.&lt;String&gt;sort(_CppClassAllIncludesDeclarationBody);
<a class="jxr_linenumber" name="L219" href="#L219">219</a>       <strong class="jxr_keyword">for</strong>(<strong class="jxr_keyword">final</strong> String path : _sort) {
<a class="jxr_linenumber" name="L220" href="#L220">220</a>         String _includeDirective_1 = CppIncludeUtil.includeDirective(path);
<a class="jxr_linenumber" name="L221" href="#L221">221</a>         _builder.append(_includeDirective_1, <span class="jxr_string">""</span>);
<a class="jxr_linenumber" name="L222" href="#L222">222</a>         _builder.newLineIfNotEmpty();
<a class="jxr_linenumber" name="L223" href="#L223">223</a>       }
<a class="jxr_linenumber" name="L224" href="#L224">224</a>     }
<a class="jxr_linenumber" name="L225" href="#L225">225</a>     _builder.newLine();
<a class="jxr_linenumber" name="L226" href="#L226">226</a>     String _CppIncludeBody = CppIncludeUtil.CppIncludeBody(classifier);
<a class="jxr_linenumber" name="L227" href="#L227">227</a>     _builder.append(_CppIncludeBody, <span class="jxr_string">""</span>);
<a class="jxr_linenumber" name="L228" href="#L228">228</a>     _builder.newLineIfNotEmpty();
<a class="jxr_linenumber" name="L229" href="#L229">229</a>     _builder.newLine();
<a class="jxr_linenumber" name="L230" href="#L230">230</a>     String _openNS = CppGenUtils.openNS(classifier);
<a class="jxr_linenumber" name="L231" href="#L231">231</a>     _builder.append(_openNS, <span class="jxr_string">""</span>);
<a class="jxr_linenumber" name="L232" href="#L232">232</a>     _builder.newLineIfNotEmpty();
<a class="jxr_linenumber" name="L233" href="#L233">233</a>     _builder.newLine();
<a class="jxr_linenumber" name="L234" href="#L234">234</a>     _builder.append(<span class="jxr_string">"/************************************************************/"</span>);
<a class="jxr_linenumber" name="L235" href="#L235">235</a>     _builder.newLine();
<a class="jxr_linenumber" name="L236" href="#L236">236</a>     TemplateBinding tb = GenUtils.getTemplateBinding(classifier);
<a class="jxr_linenumber" name="L237" href="#L237">237</a>     _builder.newLineIfNotEmpty();
<a class="jxr_linenumber" name="L238" href="#L238">238</a>     EList&lt;Element&gt; _targets = tb.getTargets();
<a class="jxr_linenumber" name="L239" href="#L239">239</a>     Element templateElement = _targets.get(0);
<a class="jxr_linenumber" name="L240" href="#L240">240</a>     _builder.newLineIfNotEmpty();
<a class="jxr_linenumber" name="L241" href="#L241">241</a>     _builder.append(<span class="jxr_string">"template class "</span>);
<a class="jxr_linenumber" name="L242" href="#L242">242</a>     Element _owner = templateElement.getOwner();
<a class="jxr_linenumber" name="L243" href="#L243">243</a>     String _name_2 = ((NamedElement) _owner).getName();
<a class="jxr_linenumber" name="L244" href="#L244">244</a>     _builder.append(_name_2, <span class="jxr_string">""</span>);
<a class="jxr_linenumber" name="L245" href="#L245">245</a>     _builder.append(<span class="jxr_string">"&lt;"</span>);
<a class="jxr_linenumber" name="L246" href="#L246">246</a>     {
<a class="jxr_linenumber" name="L247" href="#L247">247</a>       EList&lt;TemplateParameterSubstitution&gt; _parameterSubstitutions = tb.getParameterSubstitutions();
<a class="jxr_linenumber" name="L248" href="#L248">248</a>       <strong class="jxr_keyword">boolean</strong> _hasElements = false;
<a class="jxr_linenumber" name="L249" href="#L249">249</a>       <strong class="jxr_keyword">for</strong>(<strong class="jxr_keyword">final</strong> TemplateParameterSubstitution ps : _parameterSubstitutions) {
<a class="jxr_linenumber" name="L250" href="#L250">250</a>         <strong class="jxr_keyword">if</strong> (!_hasElements) {
<a class="jxr_linenumber" name="L251" href="#L251">251</a>           _hasElements = <strong class="jxr_keyword">true</strong>;
<a class="jxr_linenumber" name="L252" href="#L252">252</a>         } <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L253" href="#L253">253</a>           _builder.appendImmediate(<span class="jxr_string">", "</span>, <span class="jxr_string">""</span>);
<a class="jxr_linenumber" name="L254" href="#L254">254</a>         }
<a class="jxr_linenumber" name="L255" href="#L255">255</a>         Object _CppTemplateBindingParameter = CppTemplates.CppTemplateBindingParameter(ps);
<a class="jxr_linenumber" name="L256" href="#L256">256</a>         _builder.append(_CppTemplateBindingParameter, <span class="jxr_string">""</span>);
<a class="jxr_linenumber" name="L257" href="#L257">257</a>       }
<a class="jxr_linenumber" name="L258" href="#L258">258</a>     }
<a class="jxr_linenumber" name="L259" href="#L259">259</a>     _builder.append(<span class="jxr_string">"&gt;;"</span>);
<a class="jxr_linenumber" name="L260" href="#L260">260</a>     _builder.newLineIfNotEmpty();
<a class="jxr_linenumber" name="L261" href="#L261">261</a>     _builder.newLine();
<a class="jxr_linenumber" name="L262" href="#L262">262</a>     String _closeNS = CppGenUtils.closeNS(classifier);
<a class="jxr_linenumber" name="L263" href="#L263">263</a>     _builder.append(_closeNS, <span class="jxr_string">""</span>);
<a class="jxr_linenumber" name="L264" href="#L264">264</a>     _builder.newLineIfNotEmpty();
<a class="jxr_linenumber" name="L265" href="#L265">265</a>     _builder.newLine();
<a class="jxr_linenumber" name="L266" href="#L266">266</a>     _builder.append(<span class="jxr_string">"/************************************************************"</span>);
<a class="jxr_linenumber" name="L267" href="#L267">267</a>     _builder.newLine();
<a class="jxr_linenumber" name="L268" href="#L268">268</a>     _builder.append(<span class="jxr_string">"              "</span>);
<a class="jxr_linenumber" name="L269" href="#L269">269</a>     _builder.append(<span class="jxr_string">"End of "</span>);
<a class="jxr_linenumber" name="L270" href="#L270">270</a>     String _name_3 = classifier.getName();
<a class="jxr_linenumber" name="L271" href="#L271">271</a>     _builder.append(_name_3, <span class="jxr_string">"              "</span>);
<a class="jxr_linenumber" name="L272" href="#L272">272</a>     _builder.append(<span class="jxr_string">" template binding body"</span>);
<a class="jxr_linenumber" name="L273" href="#L273">273</a>     _builder.newLineIfNotEmpty();
<a class="jxr_linenumber" name="L274" href="#L274">274</a>     _builder.append(<span class="jxr_string">" "</span>);
<a class="jxr_linenumber" name="L275" href="#L275">275</a>     _builder.append(<span class="jxr_string">"************************************************************/"</span>);
<a class="jxr_linenumber" name="L276" href="#L276">276</a>     _builder.newLine();
<a class="jxr_linenumber" name="L277" href="#L277">277</a>     <strong class="jxr_keyword">return</strong> _builder;
<a class="jxr_linenumber" name="L278" href="#L278">278</a>   }
<a class="jxr_linenumber" name="L279" href="#L279">279</a>   
<a class="jxr_linenumber" name="L280" href="#L280">280</a>   <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> CharSequence generateClassHeaderCode(<strong class="jxr_keyword">final</strong> Classifier classifier) {
<a class="jxr_linenumber" name="L281" href="#L281">281</a>     StringConcatenation _builder = <strong class="jxr_keyword">new</strong> StringConcatenation();
<a class="jxr_linenumber" name="L282" href="#L282">282</a>     _builder.append(<span class="jxr_string">"#ifndef "</span>);
<a class="jxr_linenumber" name="L283" href="#L283">283</a>     String _fullNameUC = GenUtils.getFullNameUC(classifier);
<a class="jxr_linenumber" name="L284" href="#L284">284</a>     _builder.append(_fullNameUC, <span class="jxr_string">""</span>);
<a class="jxr_linenumber" name="L285" href="#L285">285</a>     _builder.append(<span class="jxr_string">"_H"</span>);
<a class="jxr_linenumber" name="L286" href="#L286">286</a>     _builder.newLineIfNotEmpty();
<a class="jxr_linenumber" name="L287" href="#L287">287</a>     _builder.append(<span class="jxr_string">"#define "</span>);
<a class="jxr_linenumber" name="L288" href="#L288">288</a>     String _fullNameUC_1 = GenUtils.getFullNameUC(classifier);
<a class="jxr_linenumber" name="L289" href="#L289">289</a>     _builder.append(_fullNameUC_1, <span class="jxr_string">""</span>);
<a class="jxr_linenumber" name="L290" href="#L290">290</a>     _builder.append(<span class="jxr_string">"_H"</span>);
<a class="jxr_linenumber" name="L291" href="#L291">291</a>     _builder.newLineIfNotEmpty();
<a class="jxr_linenumber" name="L292" href="#L292">292</a>     _builder.newLine();
<a class="jxr_linenumber" name="L293" href="#L293">293</a>     _builder.append(<span class="jxr_string">"/************************************************************"</span>);
<a class="jxr_linenumber" name="L294" href="#L294">294</a>     _builder.newLine();
<a class="jxr_linenumber" name="L295" href="#L295">295</a>     _builder.append(<span class="jxr_string">"              "</span>);
<a class="jxr_linenumber" name="L296" href="#L296">296</a>     String _name = classifier.getName();
<a class="jxr_linenumber" name="L297" href="#L297">297</a>     _builder.append(_name, <span class="jxr_string">"              "</span>);
<a class="jxr_linenumber" name="L298" href="#L298">298</a>     _builder.append(<span class="jxr_string">" class header"</span>);
<a class="jxr_linenumber" name="L299" href="#L299">299</a>     _builder.newLineIfNotEmpty();
<a class="jxr_linenumber" name="L300" href="#L300">300</a>     _builder.append(<span class="jxr_string">" "</span>);
<a class="jxr_linenumber" name="L301" href="#L301">301</a>     _builder.append(<span class="jxr_string">"************************************************************/"</span>);
<a class="jxr_linenumber" name="L302" href="#L302">302</a>     _builder.newLine();
<a class="jxr_linenumber" name="L303" href="#L303">303</a>     _builder.newLine();
<a class="jxr_linenumber" name="L304" href="#L304">304</a>     org.eclipse.uml2.uml.Package _<strong class="jxr_keyword">package</strong> = classifier.getPackage();
<a class="jxr_linenumber" name="L305" href="#L305">305</a>     String _cppOwnerPackageIncludePath = CppClassIncludeClassDeclaration.cppOwnerPackageIncludePath(_<strong class="jxr_keyword">package</strong>);
<a class="jxr_linenumber" name="L306" href="#L306">306</a>     String _includeDirective = CppIncludeUtil.includeDirective(_cppOwnerPackageIncludePath);
<a class="jxr_linenumber" name="L307" href="#L307">307</a>     _builder.append(_includeDirective, <span class="jxr_string">""</span>);
<a class="jxr_linenumber" name="L308" href="#L308">308</a>     _builder.newLineIfNotEmpty();
<a class="jxr_linenumber" name="L309" href="#L309">309</a>     _builder.newLine();
<a class="jxr_linenumber" name="L310" href="#L310">310</a>     {
<a class="jxr_linenumber" name="L311" href="#L311">311</a>       List&lt;String&gt; _sortedIncludePathList = CppClassifierGenerator.getSortedIncludePathList(classifier);
<a class="jxr_linenumber" name="L312" href="#L312">312</a>       <strong class="jxr_keyword">for</strong>(<strong class="jxr_keyword">final</strong> String path : _sortedIncludePathList) {
<a class="jxr_linenumber" name="L313" href="#L313">313</a>         String _includeDirective_1 = CppIncludeUtil.includeDirective(path);
<a class="jxr_linenumber" name="L314" href="#L314">314</a>         _builder.append(_includeDirective_1, <span class="jxr_string">""</span>);
<a class="jxr_linenumber" name="L315" href="#L315">315</a>         _builder.newLineIfNotEmpty();
<a class="jxr_linenumber" name="L316" href="#L316">316</a>       }
<a class="jxr_linenumber" name="L317" href="#L317">317</a>     }
<a class="jxr_linenumber" name="L318" href="#L318">318</a>     _builder.newLine();
<a class="jxr_linenumber" name="L319" href="#L319">319</a>     String _CppIncludeHeader = CppIncludeUtil.CppIncludeHeader(classifier);
<a class="jxr_linenumber" name="L320" href="#L320">320</a>     _builder.append(_CppIncludeHeader, <span class="jxr_string">""</span>);
<a class="jxr_linenumber" name="L321" href="#L321">321</a>     _builder.newLineIfNotEmpty();
<a class="jxr_linenumber" name="L322" href="#L322">322</a>     _builder.newLine();
<a class="jxr_linenumber" name="L323" href="#L323">323</a>     {
<a class="jxr_linenumber" name="L324" href="#L324">324</a>       List&lt;String&gt; _sortedDeclarePathList = CppClassifierGenerator.getSortedDeclarePathList(classifier);
<a class="jxr_linenumber" name="L325" href="#L325">325</a>       <strong class="jxr_keyword">for</strong>(<strong class="jxr_keyword">final</strong> String path_1 : _sortedDeclarePathList) {
<a class="jxr_linenumber" name="L326" href="#L326">326</a>         String _declareDirective = CppIncludeUtil.declareDirective(path_1);
<a class="jxr_linenumber" name="L327" href="#L327">327</a>         _builder.append(_declareDirective, <span class="jxr_string">""</span>);
<a class="jxr_linenumber" name="L328" href="#L328">328</a>         _builder.newLineIfNotEmpty();
<a class="jxr_linenumber" name="L329" href="#L329">329</a>       }
<a class="jxr_linenumber" name="L330" href="#L330">330</a>     }
<a class="jxr_linenumber" name="L331" href="#L331">331</a>     _builder.newLine();
<a class="jxr_linenumber" name="L332" href="#L332">332</a>     String _openNS = CppGenUtils.openNS(classifier);
<a class="jxr_linenumber" name="L333" href="#L333">333</a>     _builder.append(_openNS, <span class="jxr_string">""</span>);
<a class="jxr_linenumber" name="L334" href="#L334">334</a>     _builder.newLineIfNotEmpty();
<a class="jxr_linenumber" name="L335" href="#L335">335</a>     _builder.newLine();
<a class="jxr_linenumber" name="L336" href="#L336">336</a>     _builder.append(<span class="jxr_string">"/************************************************************/"</span>);
<a class="jxr_linenumber" name="L337" href="#L337">337</a>     _builder.newLine();
<a class="jxr_linenumber" name="L338" href="#L338">338</a>     CharSequence _CppElementDoc = CppDocumentation.CppElementDoc(classifier);
<a class="jxr_linenumber" name="L339" href="#L339">339</a>     _builder.append(_CppElementDoc, <span class="jxr_string">""</span>);
<a class="jxr_linenumber" name="L340" href="#L340">340</a>     _builder.newLineIfNotEmpty();
<a class="jxr_linenumber" name="L341" href="#L341">341</a>     CharSequence _templateSignature = CppTemplates.templateSignature(classifier);
<a class="jxr_linenumber" name="L342" href="#L342">342</a>     _builder.append(_templateSignature, <span class="jxr_string">""</span>);
<a class="jxr_linenumber" name="L343" href="#L343">343</a>     String _classUnionOrStruct = CppClassifierGenerator.classUnionOrStruct(classifier);
<a class="jxr_linenumber" name="L344" href="#L344">344</a>     _builder.append(_classUnionOrStruct, <span class="jxr_string">""</span>);
<a class="jxr_linenumber" name="L345" href="#L345">345</a>     _builder.append(<span class="jxr_string">" "</span>);
<a class="jxr_linenumber" name="L346" href="#L346">346</a>     String _name_1 = classifier.getName();
<a class="jxr_linenumber" name="L347" href="#L347">347</a>     _builder.append(_name_1, <span class="jxr_string">""</span>);
<a class="jxr_linenumber" name="L348" href="#L348">348</a>     CharSequence _CppClassInheritedDeclarations = CppClassInheritedDeclarations.CppClassInheritedDeclarations(classifier);
<a class="jxr_linenumber" name="L349" href="#L349">349</a>     _builder.append(_CppClassInheritedDeclarations, <span class="jxr_string">""</span>);
<a class="jxr_linenumber" name="L350" href="#L350">350</a>     _builder.append(<span class="jxr_string">" {"</span>);
<a class="jxr_linenumber" name="L351" href="#L351">351</a>     _builder.newLineIfNotEmpty();
<a class="jxr_linenumber" name="L352" href="#L352">352</a>     _builder.append(<span class="jxr_string">"    "</span>);
<a class="jxr_linenumber" name="L353" href="#L353">353</a>     CppClassFriendDeclaration.CppClassIncludeFriendDeclaration(classifier);
<a class="jxr_linenumber" name="L354" href="#L354">354</a>     Object _CppClassTypeAndEnum = CppClassTypeAndEnum.CppClassTypeAndEnum(classifier);
<a class="jxr_linenumber" name="L355" href="#L355">355</a>     _builder.append(_CppClassTypeAndEnum, <span class="jxr_string">"    "</span>);
<a class="jxr_linenumber" name="L356" href="#L356">356</a>     _builder.newLineIfNotEmpty();
<a class="jxr_linenumber" name="L357" href="#L357">357</a>     _builder.append(<span class="jxr_string">"\t"</span>);
<a class="jxr_linenumber" name="L358" href="#L358">358</a>     VisibilityKind publicVisibility = VisibilityKind.PUBLIC_LITERAL;
<a class="jxr_linenumber" name="L359" href="#L359">359</a>     _builder.newLineIfNotEmpty();
<a class="jxr_linenumber" name="L360" href="#L360">360</a>     _builder.append(<span class="jxr_string">"\t"</span>);
<a class="jxr_linenumber" name="L361" href="#L361">361</a>     String _defaultInitializer = CppClassifierGenerator.defaultInitializer(classifier);
<a class="jxr_linenumber" name="L362" href="#L362">362</a>     String _section = CppGenUtils.getSection(publicVisibility, _defaultInitializer);
<a class="jxr_linenumber" name="L363" href="#L363">363</a>     _builder.append(_section, <span class="jxr_string">"\t"</span>);
<a class="jxr_linenumber" name="L364" href="#L364">364</a>     _builder.newLineIfNotEmpty();
<a class="jxr_linenumber" name="L365" href="#L365">365</a>     _builder.append(<span class="jxr_string">"\t"</span>);
<a class="jxr_linenumber" name="L366" href="#L366">366</a>     CharSequence _CppClassAttributesDeclaration = CppClassAttributesDeclaration.CppClassAttributesDeclaration(classifier, publicVisibility);
<a class="jxr_linenumber" name="L367" href="#L367">367</a>     String _string = _CppClassAttributesDeclaration.toString();
<a class="jxr_linenumber" name="L368" href="#L368">368</a>     String _section_1 = CppGenUtils.getSection(publicVisibility, _string);
<a class="jxr_linenumber" name="L369" href="#L369">369</a>     _builder.append(_section_1, <span class="jxr_string">"\t"</span>);
<a class="jxr_linenumber" name="L370" href="#L370">370</a>     _builder.newLineIfNotEmpty();
<a class="jxr_linenumber" name="L371" href="#L371">371</a>     _builder.append(<span class="jxr_string">"\t"</span>);
<a class="jxr_linenumber" name="L372" href="#L372">372</a>     CharSequence _CppClassOperationsDeclaration = CppClassOperationsDeclaration.CppClassOperationsDeclaration(classifier, publicVisibility);
<a class="jxr_linenumber" name="L373" href="#L373">373</a>     String _string_1 = _CppClassOperationsDeclaration.toString();
<a class="jxr_linenumber" name="L374" href="#L374">374</a>     String _section_2 = CppGenUtils.getSection(publicVisibility, _string_1);
<a class="jxr_linenumber" name="L375" href="#L375">375</a>     _builder.append(_section_2, <span class="jxr_string">"\t"</span>);
<a class="jxr_linenumber" name="L376" href="#L376">376</a>     _builder.newLineIfNotEmpty();
<a class="jxr_linenumber" name="L377" href="#L377">377</a>     _builder.newLine();
<a class="jxr_linenumber" name="L378" href="#L378">378</a>     _builder.append(<span class="jxr_string">"\t"</span>);
<a class="jxr_linenumber" name="L379" href="#L379">379</a>     VisibilityKind protectedVisibility = VisibilityKind.PROTECTED_LITERAL;
<a class="jxr_linenumber" name="L380" href="#L380">380</a>     _builder.newLineIfNotEmpty();
<a class="jxr_linenumber" name="L381" href="#L381">381</a>     _builder.append(<span class="jxr_string">"\t"</span>);
<a class="jxr_linenumber" name="L382" href="#L382">382</a>     CharSequence _CppClassAttributesDeclaration_1 = CppClassAttributesDeclaration.CppClassAttributesDeclaration(classifier, protectedVisibility);
<a class="jxr_linenumber" name="L383" href="#L383">383</a>     String _string_2 = _CppClassAttributesDeclaration_1.toString();
<a class="jxr_linenumber" name="L384" href="#L384">384</a>     String _section_3 = CppGenUtils.getSection(protectedVisibility, _string_2);
<a class="jxr_linenumber" name="L385" href="#L385">385</a>     _builder.append(_section_3, <span class="jxr_string">"\t"</span>);
<a class="jxr_linenumber" name="L386" href="#L386">386</a>     _builder.newLineIfNotEmpty();
<a class="jxr_linenumber" name="L387" href="#L387">387</a>     _builder.append(<span class="jxr_string">"\t"</span>);
<a class="jxr_linenumber" name="L388" href="#L388">388</a>     CharSequence _CppClassOperationsDeclaration_1 = CppClassOperationsDeclaration.CppClassOperationsDeclaration(classifier, protectedVisibility);
<a class="jxr_linenumber" name="L389" href="#L389">389</a>     String _string_3 = _CppClassOperationsDeclaration_1.toString();
<a class="jxr_linenumber" name="L390" href="#L390">390</a>     String _section_4 = CppGenUtils.getSection(protectedVisibility, _string_3);
<a class="jxr_linenumber" name="L391" href="#L391">391</a>     _builder.append(_section_4, <span class="jxr_string">"\t"</span>);
<a class="jxr_linenumber" name="L392" href="#L392">392</a>     _builder.newLineIfNotEmpty();
<a class="jxr_linenumber" name="L393" href="#L393">393</a>     _builder.newLine();
<a class="jxr_linenumber" name="L394" href="#L394">394</a>     _builder.append(<span class="jxr_string">"\t"</span>);
<a class="jxr_linenumber" name="L395" href="#L395">395</a>     VisibilityKind privateVisibility = VisibilityKind.PRIVATE_LITERAL;
<a class="jxr_linenumber" name="L396" href="#L396">396</a>     _builder.newLineIfNotEmpty();
<a class="jxr_linenumber" name="L397" href="#L397">397</a>     _builder.append(<span class="jxr_string">"\t"</span>);
<a class="jxr_linenumber" name="L398" href="#L398">398</a>     CharSequence _CppClassAttributesDeclaration_2 = CppClassAttributesDeclaration.CppClassAttributesDeclaration(classifier, privateVisibility);
<a class="jxr_linenumber" name="L399" href="#L399">399</a>     String _string_4 = _CppClassAttributesDeclaration_2.toString();
<a class="jxr_linenumber" name="L400" href="#L400">400</a>     String _section_5 = CppGenUtils.getSection(privateVisibility, _string_4);
<a class="jxr_linenumber" name="L401" href="#L401">401</a>     _builder.append(_section_5, <span class="jxr_string">"\t"</span>);
<a class="jxr_linenumber" name="L402" href="#L402">402</a>     _builder.newLineIfNotEmpty();
<a class="jxr_linenumber" name="L403" href="#L403">403</a>     _builder.append(<span class="jxr_string">"\t"</span>);
<a class="jxr_linenumber" name="L404" href="#L404">404</a>     CharSequence _CppClassOperationsDeclaration_2 = CppClassOperationsDeclaration.CppClassOperationsDeclaration(classifier, privateVisibility);
<a class="jxr_linenumber" name="L405" href="#L405">405</a>     String _string_5 = _CppClassOperationsDeclaration_2.toString();
<a class="jxr_linenumber" name="L406" href="#L406">406</a>     String _section_6 = CppGenUtils.getSection(privateVisibility, _string_5);
<a class="jxr_linenumber" name="L407" href="#L407">407</a>     _builder.append(_section_6, <span class="jxr_string">"\t"</span>);
<a class="jxr_linenumber" name="L408" href="#L408">408</a>     _builder.newLineIfNotEmpty();
<a class="jxr_linenumber" name="L409" href="#L409">409</a>     _builder.append(<span class="jxr_string">"};"</span>);
<a class="jxr_linenumber" name="L410" href="#L410">410</a>     _builder.newLine();
<a class="jxr_linenumber" name="L411" href="#L411">411</a>     _builder.append(<span class="jxr_string">"/************************************************************/"</span>);
<a class="jxr_linenumber" name="L412" href="#L412">412</a>     _builder.newLine();
<a class="jxr_linenumber" name="L413" href="#L413">413</a>     _builder.append(<span class="jxr_string">"/* External declarations (package visibility)               */"</span>);
<a class="jxr_linenumber" name="L414" href="#L414">414</a>     _builder.newLine();
<a class="jxr_linenumber" name="L415" href="#L415">415</a>     VisibilityKind packageVisibility = VisibilityKind.PACKAGE_LITERAL;
<a class="jxr_linenumber" name="L416" href="#L416">416</a>     _builder.newLineIfNotEmpty();
<a class="jxr_linenumber" name="L417" href="#L417">417</a>     CharSequence _CppClassAttributesDeclaration_3 = CppClassAttributesDeclaration.CppClassAttributesDeclaration(classifier, packageVisibility);
<a class="jxr_linenumber" name="L418" href="#L418">418</a>     _builder.append(_CppClassAttributesDeclaration_3, <span class="jxr_string">""</span>);
<a class="jxr_linenumber" name="L419" href="#L419">419</a>     _builder.newLineIfNotEmpty();
<a class="jxr_linenumber" name="L420" href="#L420">420</a>     CharSequence _CppClassOperationsDeclaration_3 = CppClassOperationsDeclaration.CppClassOperationsDeclaration(classifier, packageVisibility);
<a class="jxr_linenumber" name="L421" href="#L421">421</a>     _builder.append(_CppClassOperationsDeclaration_3, <span class="jxr_string">""</span>);
<a class="jxr_linenumber" name="L422" href="#L422">422</a>     _builder.newLineIfNotEmpty();
<a class="jxr_linenumber" name="L423" href="#L423">423</a>     _builder.append(<span class="jxr_string">"/************************************************************/"</span>);
<a class="jxr_linenumber" name="L424" href="#L424">424</a>     _builder.newLine();
<a class="jxr_linenumber" name="L425" href="#L425">425</a>     _builder.newLine();
<a class="jxr_linenumber" name="L426" href="#L426">426</a>     {
<a class="jxr_linenumber" name="L427" href="#L427">427</a>       <strong class="jxr_keyword">boolean</strong> _isTemplate = CppTemplates.isTemplate(classifier);
<a class="jxr_linenumber" name="L428" href="#L428">428</a>       <strong class="jxr_keyword">if</strong> (_isTemplate) {
<a class="jxr_linenumber" name="L429" href="#L429">429</a>         _builder.append(<span class="jxr_string">"/************************************************************/"</span>);
<a class="jxr_linenumber" name="L430" href="#L430">430</a>         _builder.newLine();
<a class="jxr_linenumber" name="L431" href="#L431">431</a>         _builder.append(<span class="jxr_string">"/* Template functions                                       */"</span>);
<a class="jxr_linenumber" name="L432" href="#L432">432</a>         _builder.newLine();
<a class="jxr_linenumber" name="L433" href="#L433">433</a>         CharSequence _CppClassOperationsImplementation = CppClassOperationsImplementation.CppClassOperationsImplementation(classifier, false);
<a class="jxr_linenumber" name="L434" href="#L434">434</a>         _builder.append(_CppClassOperationsImplementation, <span class="jxr_string">""</span>);
<a class="jxr_linenumber" name="L435" href="#L435">435</a>         _builder.newLineIfNotEmpty();
<a class="jxr_linenumber" name="L436" href="#L436">436</a>       }
<a class="jxr_linenumber" name="L437" href="#L437">437</a>     }
<a class="jxr_linenumber" name="L438" href="#L438">438</a>     _builder.newLine();
<a class="jxr_linenumber" name="L439" href="#L439">439</a>     _builder.append(<span class="jxr_string">"/* Inline functions                                         */"</span>);
<a class="jxr_linenumber" name="L440" href="#L440">440</a>     _builder.newLine();
<a class="jxr_linenumber" name="L441" href="#L441">441</a>     CharSequence _CppClassOperationsImplementation_1 = CppClassOperationsImplementation.CppClassOperationsImplementation(classifier, <strong class="jxr_keyword">true</strong>);
<a class="jxr_linenumber" name="L442" href="#L442">442</a>     _builder.append(_CppClassOperationsImplementation_1, <span class="jxr_string">""</span>);
<a class="jxr_linenumber" name="L443" href="#L443">443</a>     _builder.newLineIfNotEmpty();
<a class="jxr_linenumber" name="L444" href="#L444">444</a>     String _closeNS = CppGenUtils.closeNS(classifier);
<a class="jxr_linenumber" name="L445" href="#L445">445</a>     _builder.append(_closeNS, <span class="jxr_string">""</span>);
<a class="jxr_linenumber" name="L446" href="#L446">446</a>     _builder.newLineIfNotEmpty();
<a class="jxr_linenumber" name="L447" href="#L447">447</a>     _builder.newLine();
<a class="jxr_linenumber" name="L448" href="#L448">448</a>     _builder.append(<span class="jxr_string">"/************************************************************"</span>);
<a class="jxr_linenumber" name="L449" href="#L449">449</a>     _builder.newLine();
<a class="jxr_linenumber" name="L450" href="#L450">450</a>     _builder.append(<span class="jxr_string">"              "</span>);
<a class="jxr_linenumber" name="L451" href="#L451">451</a>     _builder.append(<span class="jxr_string">"End of "</span>);
<a class="jxr_linenumber" name="L452" href="#L452">452</a>     String _name_2 = classifier.getName();
<a class="jxr_linenumber" name="L453" href="#L453">453</a>     _builder.append(_name_2, <span class="jxr_string">"              "</span>);
<a class="jxr_linenumber" name="L454" href="#L454">454</a>     _builder.append(<span class="jxr_string">" class header"</span>);
<a class="jxr_linenumber" name="L455" href="#L455">455</a>     _builder.newLineIfNotEmpty();
<a class="jxr_linenumber" name="L456" href="#L456">456</a>     _builder.append(<span class="jxr_string">" "</span>);
<a class="jxr_linenumber" name="L457" href="#L457">457</a>     _builder.append(<span class="jxr_string">"************************************************************/"</span>);
<a class="jxr_linenumber" name="L458" href="#L458">458</a>     _builder.newLine();
<a class="jxr_linenumber" name="L459" href="#L459">459</a>     _builder.newLine();
<a class="jxr_linenumber" name="L460" href="#L460">460</a>     _builder.append(<span class="jxr_string">"#endif"</span>);
<a class="jxr_linenumber" name="L461" href="#L461">461</a>     _builder.newLine();
<a class="jxr_linenumber" name="L462" href="#L462">462</a>     <strong class="jxr_keyword">return</strong> _builder;
<a class="jxr_linenumber" name="L463" href="#L463">463</a>   }
<a class="jxr_linenumber" name="L464" href="#L464">464</a>   
<a class="jxr_linenumber" name="L465" href="#L465">465</a>   <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> String classUnionOrStruct(<strong class="jxr_keyword">final</strong> Classifier classifier) {
<a class="jxr_linenumber" name="L466" href="#L466">466</a>     <strong class="jxr_keyword">boolean</strong> _hasStereotype = GenUtils.hasStereotype(classifier, Union.<strong class="jxr_keyword">class</strong>);
<a class="jxr_linenumber" name="L467" href="#L467">467</a>     <strong class="jxr_keyword">if</strong> (_hasStereotype) {
<a class="jxr_linenumber" name="L468" href="#L468">468</a>       <strong class="jxr_keyword">return</strong> <span class="jxr_string">"union"</span>;
<a class="jxr_linenumber" name="L469" href="#L469">469</a>     } <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L470" href="#L470">470</a>       <strong class="jxr_keyword">if</strong> ((classifier instanceof DataType)) {
<a class="jxr_linenumber" name="L471" href="#L471">471</a>         CppGenUtils.resetVisibility(VisibilityKind.PUBLIC_LITERAL);
<a class="jxr_linenumber" name="L472" href="#L472">472</a>         <strong class="jxr_keyword">return</strong> <span class="jxr_string">"struct"</span>;
<a class="jxr_linenumber" name="L473" href="#L473">473</a>       } <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L474" href="#L474">474</a>         CppGenUtils.resetVisibility(VisibilityKind.PRIVATE_LITERAL);
<a class="jxr_linenumber" name="L475" href="#L475">475</a>         <strong class="jxr_keyword">return</strong> <span class="jxr_string">"class"</span>;
<a class="jxr_linenumber" name="L476" href="#L476">476</a>       }
<a class="jxr_linenumber" name="L477" href="#L477">477</a>     }
<a class="jxr_linenumber" name="L478" href="#L478">478</a>   }
<a class="jxr_linenumber" name="L479" href="#L479">479</a>   
<a class="jxr_linenumber" name="L480" href="#L480">480</a>   <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L481" href="#L481">481</a> <em class="jxr_javadoccomment">   * default initializer for non-static attributes with a default value TODO: should be disabled by default, since non-static members can be initialized directly in C++ 011</em>
<a class="jxr_linenumber" name="L482" href="#L482">482</a> <em class="jxr_javadoccomment">   */</em>
<a class="jxr_linenumber" name="L483" href="#L483">483</a>   <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> String defaultInitializer(<strong class="jxr_keyword">final</strong> Classifier classifier) {
<a class="jxr_linenumber" name="L484" href="#L484">484</a>     StringConcatenation _builder = <strong class="jxr_keyword">new</strong> StringConcatenation();
<a class="jxr_linenumber" name="L485" href="#L485">485</a>     {
<a class="jxr_linenumber" name="L486" href="#L486">486</a>       Collection&lt;Operation&gt; _ownedOperations = CppOperations.getOwnedOperations(classifier);
<a class="jxr_linenumber" name="L487" href="#L487">487</a>       <strong class="jxr_keyword">final</strong> Function1&lt;Operation, Boolean&gt; _function = <strong class="jxr_keyword">new</strong> Function1&lt;Operation, Boolean&gt;() {
<a class="jxr_linenumber" name="L488" href="#L488">488</a>         @Override
<a class="jxr_linenumber" name="L489" href="#L489">489</a>         <strong class="jxr_keyword">public</strong> Boolean apply(<strong class="jxr_keyword">final</strong> Operation it) {
<a class="jxr_linenumber" name="L490" href="#L490">490</a>           <strong class="jxr_keyword">return</strong> Boolean.valueOf(GenUtils.hasStereotype(it, Create.<strong class="jxr_keyword">class</strong>));
<a class="jxr_linenumber" name="L491" href="#L491">491</a>         }
<a class="jxr_linenumber" name="L492" href="#L492">492</a>       };
<a class="jxr_linenumber" name="L493" href="#L493">493</a>       Iterable&lt;Operation&gt; _filter = IterableExtensions.&lt;Operation&gt;filter(_ownedOperations, _function);
<a class="jxr_linenumber" name="L494" href="#L494">494</a>       <strong class="jxr_keyword">boolean</strong> _isEmpty = IterableExtensions.isEmpty(_filter);
<a class="jxr_linenumber" name="L495" href="#L495">495</a>       <strong class="jxr_keyword">if</strong> (_isEmpty) {
<a class="jxr_linenumber" name="L496" href="#L496">496</a>         EList&lt;Property&gt; _attributes = classifier.getAttributes();
<a class="jxr_linenumber" name="L497" href="#L497">497</a>         <strong class="jxr_keyword">final</strong> Function1&lt;Property, Boolean&gt; _function_1 = <strong class="jxr_keyword">new</strong> Function1&lt;Property, Boolean&gt;() {
<a class="jxr_linenumber" name="L498" href="#L498">498</a>           @Override
<a class="jxr_linenumber" name="L499" href="#L499">499</a>           <strong class="jxr_keyword">public</strong> Boolean apply(<strong class="jxr_keyword">final</strong> Property it) {
<a class="jxr_linenumber" name="L500" href="#L500">500</a>             <strong class="jxr_keyword">boolean</strong> _and = false;
<a class="jxr_linenumber" name="L501" href="#L501">501</a>             <strong class="jxr_keyword">boolean</strong> _and_1 = false;
<a class="jxr_linenumber" name="L502" href="#L502">502</a>             <strong class="jxr_keyword">boolean</strong> _isStatic = it.isStatic();
<a class="jxr_linenumber" name="L503" href="#L503">503</a>             <strong class="jxr_keyword">boolean</strong> _equals = (_isStatic == false);
<a class="jxr_linenumber" name="L504" href="#L504">504</a>             <strong class="jxr_keyword">if</strong> (!_equals) {
<a class="jxr_linenumber" name="L505" href="#L505">505</a>               _and_1 = false;
<a class="jxr_linenumber" name="L506" href="#L506">506</a>             } <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L507" href="#L507">507</a>               ValueSpecification _defaultValue = it.getDefaultValue();
<a class="jxr_linenumber" name="L508" href="#L508">508</a>               <strong class="jxr_keyword">boolean</strong> _notEquals = (!Objects.equal(_defaultValue, <strong class="jxr_keyword">null</strong>));
<a class="jxr_linenumber" name="L509" href="#L509">509</a>               _and_1 = _notEquals;
<a class="jxr_linenumber" name="L510" href="#L510">510</a>             }
<a class="jxr_linenumber" name="L511" href="#L511">511</a>             <strong class="jxr_keyword">if</strong> (!_and_1) {
<a class="jxr_linenumber" name="L512" href="#L512">512</a>               _and = false;
<a class="jxr_linenumber" name="L513" href="#L513">513</a>             } <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L514" href="#L514">514</a>               ValueSpecification _defaultValue_1 = it.getDefaultValue();
<a class="jxr_linenumber" name="L515" href="#L515">515</a>               String _stringValue = _defaultValue_1.stringValue();
<a class="jxr_linenumber" name="L516" href="#L516">516</a>               <strong class="jxr_keyword">boolean</strong> _notEquals_1 = (!Objects.equal(_stringValue, <strong class="jxr_keyword">null</strong>));
<a class="jxr_linenumber" name="L517" href="#L517">517</a>               _and = _notEquals_1;
<a class="jxr_linenumber" name="L518" href="#L518">518</a>             }
<a class="jxr_linenumber" name="L519" href="#L519">519</a>             <strong class="jxr_keyword">return</strong> Boolean.valueOf(_and);
<a class="jxr_linenumber" name="L520" href="#L520">520</a>           }
<a class="jxr_linenumber" name="L521" href="#L521">521</a>         };
<a class="jxr_linenumber" name="L522" href="#L522">522</a>         Iterable&lt;Property&gt; attributeList = IterableExtensions.&lt;Property&gt;filter(_attributes, _function_1);
<a class="jxr_linenumber" name="L523" href="#L523">523</a>         _builder.newLineIfNotEmpty();
<a class="jxr_linenumber" name="L524" href="#L524">524</a>         {
<a class="jxr_linenumber" name="L525" href="#L525">525</a>           <strong class="jxr_keyword">boolean</strong> _isEmpty_1 = IterableExtensions.isEmpty(attributeList);
<a class="jxr_linenumber" name="L526" href="#L526">526</a>           <strong class="jxr_keyword">boolean</strong> _not = (!_isEmpty_1);
<a class="jxr_linenumber" name="L527" href="#L527">527</a>           <strong class="jxr_keyword">if</strong> (_not) {
<a class="jxr_linenumber" name="L528" href="#L528">528</a>             String _name = classifier.getName();
<a class="jxr_linenumber" name="L529" href="#L529">529</a>             _builder.append(_name, <span class="jxr_string">""</span>);
<a class="jxr_linenumber" name="L530" href="#L530">530</a>             _builder.append(<span class="jxr_string">"() : "</span>);
<a class="jxr_linenumber" name="L531" href="#L531">531</a>             {
<a class="jxr_linenumber" name="L532" href="#L532">532</a>               <strong class="jxr_keyword">boolean</strong> _hasElements = false;
<a class="jxr_linenumber" name="L533" href="#L533">533</a>               <strong class="jxr_keyword">for</strong>(<strong class="jxr_keyword">final</strong> Property a : attributeList) {
<a class="jxr_linenumber" name="L534" href="#L534">534</a>                 <strong class="jxr_keyword">if</strong> (!_hasElements) {
<a class="jxr_linenumber" name="L535" href="#L535">535</a>                   _hasElements = <strong class="jxr_keyword">true</strong>;
<a class="jxr_linenumber" name="L536" href="#L536">536</a>                 } <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L537" href="#L537">537</a>                   _builder.appendImmediate(<span class="jxr_string">", "</span>, <span class="jxr_string">""</span>);
<a class="jxr_linenumber" name="L538" href="#L538">538</a>                 }
<a class="jxr_linenumber" name="L539" href="#L539">539</a>                 String _name_1 = a.getName();
<a class="jxr_linenumber" name="L540" href="#L540">540</a>                 _builder.append(_name_1, <span class="jxr_string">""</span>);
<a class="jxr_linenumber" name="L541" href="#L541">541</a>                 _builder.append(<span class="jxr_string">"("</span>);
<a class="jxr_linenumber" name="L542" href="#L542">542</a>                 ValueSpecification _defaultValue = a.getDefaultValue();
<a class="jxr_linenumber" name="L543" href="#L543">543</a>                 String _stringValue = _defaultValue.stringValue();
<a class="jxr_linenumber" name="L544" href="#L544">544</a>                 _builder.append(_stringValue, <span class="jxr_string">""</span>);
<a class="jxr_linenumber" name="L545" href="#L545">545</a>                 _builder.append(<span class="jxr_string">")"</span>);
<a class="jxr_linenumber" name="L546" href="#L546">546</a>               }
<a class="jxr_linenumber" name="L547" href="#L547">547</a>             }
<a class="jxr_linenumber" name="L548" href="#L548">548</a>             _builder.append(<span class="jxr_string">" {}"</span>);
<a class="jxr_linenumber" name="L549" href="#L549">549</a>             _builder.newLineIfNotEmpty();
<a class="jxr_linenumber" name="L550" href="#L550">550</a>           }
<a class="jxr_linenumber" name="L551" href="#L551">551</a>         }
<a class="jxr_linenumber" name="L552" href="#L552">552</a>         _builder.append(<span class="jxr_string">"\t\t"</span>);
<a class="jxr_linenumber" name="L553" href="#L553">553</a>       }
<a class="jxr_linenumber" name="L554" href="#L554">554</a>     }
<a class="jxr_linenumber" name="L555" href="#L555">555</a>     String code = _builder.toString();
<a class="jxr_linenumber" name="L556" href="#L556">556</a>     <strong class="jxr_keyword">return</strong> code.trim();
<a class="jxr_linenumber" name="L557" href="#L557">557</a>   }
<a class="jxr_linenumber" name="L558" href="#L558">558</a>   
<a class="jxr_linenumber" name="L559" href="#L559">559</a>   <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> CharSequence generateClassBodyCode(<strong class="jxr_keyword">final</strong> Classifier classifier) {
<a class="jxr_linenumber" name="L560" href="#L560">560</a>     StringConcatenation _builder = <strong class="jxr_keyword">new</strong> StringConcatenation();
<a class="jxr_linenumber" name="L561" href="#L561">561</a>     _builder.append(<span class="jxr_string">"#define "</span>);
<a class="jxr_linenumber" name="L562" href="#L562">562</a>     String _fullName = GenUtils.getFullName(classifier);
<a class="jxr_linenumber" name="L563" href="#L563">563</a>     _builder.append(_fullName, <span class="jxr_string">""</span>);
<a class="jxr_linenumber" name="L564" href="#L564">564</a>     _builder.append(<span class="jxr_string">"_BODY"</span>);
<a class="jxr_linenumber" name="L565" href="#L565">565</a>     _builder.newLineIfNotEmpty();
<a class="jxr_linenumber" name="L566" href="#L566">566</a>     _builder.newLine();
<a class="jxr_linenumber" name="L567" href="#L567">567</a>     _builder.append(<span class="jxr_string">"/************************************************************"</span>);
<a class="jxr_linenumber" name="L568" href="#L568">568</a>     _builder.newLine();
<a class="jxr_linenumber" name="L569" href="#L569">569</a>     _builder.append(<span class="jxr_string">"              "</span>);
<a class="jxr_linenumber" name="L570" href="#L570">570</a>     String _name = classifier.getName();
<a class="jxr_linenumber" name="L571" href="#L571">571</a>     _builder.append(_name, <span class="jxr_string">"              "</span>);
<a class="jxr_linenumber" name="L572" href="#L572">572</a>     _builder.append(<span class="jxr_string">" class body"</span>);
<a class="jxr_linenumber" name="L573" href="#L573">573</a>     _builder.newLineIfNotEmpty();
<a class="jxr_linenumber" name="L574" href="#L574">574</a>     _builder.append(<span class="jxr_string">" "</span>);
<a class="jxr_linenumber" name="L575" href="#L575">575</a>     _builder.append(<span class="jxr_string">"************************************************************/"</span>);
<a class="jxr_linenumber" name="L576" href="#L576">576</a>     _builder.newLine();
<a class="jxr_linenumber" name="L577" href="#L577">577</a>     _builder.newLine();
<a class="jxr_linenumber" name="L578" href="#L578">578</a>     String _CppIncludePreBody = CppIncludeUtil.CppIncludePreBody(classifier);
<a class="jxr_linenumber" name="L579" href="#L579">579</a>     _builder.append(_CppIncludePreBody, <span class="jxr_string">""</span>);
<a class="jxr_linenumber" name="L580" href="#L580">580</a>     _builder.newLineIfNotEmpty();
<a class="jxr_linenumber" name="L581" href="#L581">581</a>     _builder.newLine();
<a class="jxr_linenumber" name="L582" href="#L582">582</a>     _builder.append(<span class="jxr_string">"// include associated header file"</span>);
<a class="jxr_linenumber" name="L583" href="#L583">583</a>     _builder.newLine();
<a class="jxr_linenumber" name="L584" href="#L584">584</a>     org.eclipse.uml2.uml.Package _nearestPackage = classifier.getNearestPackage();
<a class="jxr_linenumber" name="L585" href="#L585">585</a>     String _fullPath = GenUtils.getFullPath(_nearestPackage);
<a class="jxr_linenumber" name="L586" href="#L586">586</a>     String _plus = (_fullPath + <span class="jxr_string">"/"</span>);
<a class="jxr_linenumber" name="L587" href="#L587">587</a>     String _name_1 = classifier.getName();
<a class="jxr_linenumber" name="L588" href="#L588">588</a>     String _plus_1 = (_plus + _name_1);
<a class="jxr_linenumber" name="L589" href="#L589">589</a>     String _plus_2 = (_plus_1 + <span class="jxr_string">"."</span>);
<a class="jxr_linenumber" name="L590" href="#L590">590</a>     String _headerSuffix = CppCodeGenUtils.getHeaderSuffix();
<a class="jxr_linenumber" name="L591" href="#L591">591</a>     String _plus_3 = (_plus_2 + _headerSuffix);
<a class="jxr_linenumber" name="L592" href="#L592">592</a>     String _includeDirective = CppIncludeUtil.includeDirective(_plus_3);
<a class="jxr_linenumber" name="L593" href="#L593">593</a>     _builder.append(_includeDirective, <span class="jxr_string">""</span>);
<a class="jxr_linenumber" name="L594" href="#L594">594</a>     _builder.newLineIfNotEmpty();
<a class="jxr_linenumber" name="L595" href="#L595">595</a>     _builder.newLine();
<a class="jxr_linenumber" name="L596" href="#L596">596</a>     _builder.append(<span class="jxr_string">"// Derived includes directives"</span>);
<a class="jxr_linenumber" name="L597" href="#L597">597</a>     _builder.newLine();
<a class="jxr_linenumber" name="L598" href="#L598">598</a>     {
<a class="jxr_linenumber" name="L599" href="#L599">599</a>       Iterable&lt;String&gt; _CppClassAllIncludesDeclarationBody = CppClassIncludeClassDeclaration.CppClassAllIncludesDeclarationBody(classifier);
<a class="jxr_linenumber" name="L600" href="#L600">600</a>       List&lt;String&gt; _sort = IterableExtensions.&lt;String&gt;sort(_CppClassAllIncludesDeclarationBody);
<a class="jxr_linenumber" name="L601" href="#L601">601</a>       <strong class="jxr_keyword">for</strong>(<strong class="jxr_keyword">final</strong> String path : _sort) {
<a class="jxr_linenumber" name="L602" href="#L602">602</a>         String _includeDirective_1 = CppIncludeUtil.includeDirective(path);
<a class="jxr_linenumber" name="L603" href="#L603">603</a>         _builder.append(_includeDirective_1, <span class="jxr_string">""</span>);
<a class="jxr_linenumber" name="L604" href="#L604">604</a>         _builder.newLineIfNotEmpty();
<a class="jxr_linenumber" name="L605" href="#L605">605</a>       }
<a class="jxr_linenumber" name="L606" href="#L606">606</a>     }
<a class="jxr_linenumber" name="L607" href="#L607">607</a>     _builder.newLine();
<a class="jxr_linenumber" name="L608" href="#L608">608</a>     String _CppIncludeBody = CppIncludeUtil.CppIncludeBody(classifier);
<a class="jxr_linenumber" name="L609" href="#L609">609</a>     _builder.append(_CppIncludeBody, <span class="jxr_string">""</span>);
<a class="jxr_linenumber" name="L610" href="#L610">610</a>     _builder.newLineIfNotEmpty();
<a class="jxr_linenumber" name="L611" href="#L611">611</a>     _builder.newLine();
<a class="jxr_linenumber" name="L612" href="#L612">612</a>     String _openNS = CppGenUtils.openNS(classifier);
<a class="jxr_linenumber" name="L613" href="#L613">613</a>     _builder.append(_openNS, <span class="jxr_string">""</span>);
<a class="jxr_linenumber" name="L614" href="#L614">614</a>     _builder.newLineIfNotEmpty();
<a class="jxr_linenumber" name="L615" href="#L615">615</a>     _builder.newLine();
<a class="jxr_linenumber" name="L616" href="#L616">616</a>     String _CppStaticAttributes = CppAttribute.CppStaticAttributes(classifier);
<a class="jxr_linenumber" name="L617" href="#L617">617</a>     _builder.append(_CppStaticAttributes, <span class="jxr_string">""</span>);
<a class="jxr_linenumber" name="L618" href="#L618">618</a>     _builder.newLineIfNotEmpty();
<a class="jxr_linenumber" name="L619" href="#L619">619</a>     _builder.newLine();
<a class="jxr_linenumber" name="L620" href="#L620">620</a>     {
<a class="jxr_linenumber" name="L621" href="#L621">621</a>       <strong class="jxr_keyword">boolean</strong> _isTemplate = classifier.isTemplate();
<a class="jxr_linenumber" name="L622" href="#L622">622</a>       <strong class="jxr_keyword">boolean</strong> _not = (!_isTemplate);
<a class="jxr_linenumber" name="L623" href="#L623">623</a>       <strong class="jxr_keyword">if</strong> (_not) {
<a class="jxr_linenumber" name="L624" href="#L624">624</a>         CharSequence _CppClassOperationsImplementation = CppClassOperationsImplementation.CppClassOperationsImplementation(classifier, false);
<a class="jxr_linenumber" name="L625" href="#L625">625</a>         _builder.append(_CppClassOperationsImplementation, <span class="jxr_string">""</span>);
<a class="jxr_linenumber" name="L626" href="#L626">626</a>         _builder.newLineIfNotEmpty();
<a class="jxr_linenumber" name="L627" href="#L627">627</a>       }
<a class="jxr_linenumber" name="L628" href="#L628">628</a>     }
<a class="jxr_linenumber" name="L629" href="#L629">629</a>     _builder.newLine();
<a class="jxr_linenumber" name="L630" href="#L630">630</a>     String _closeNS = CppGenUtils.closeNS(classifier);
<a class="jxr_linenumber" name="L631" href="#L631">631</a>     _builder.append(_closeNS, <span class="jxr_string">""</span>);
<a class="jxr_linenumber" name="L632" href="#L632">632</a>     _builder.newLineIfNotEmpty();
<a class="jxr_linenumber" name="L633" href="#L633">633</a>     _builder.newLine();
<a class="jxr_linenumber" name="L634" href="#L634">634</a>     _builder.append(<span class="jxr_string">"/************************************************************"</span>);
<a class="jxr_linenumber" name="L635" href="#L635">635</a>     _builder.newLine();
<a class="jxr_linenumber" name="L636" href="#L636">636</a>     _builder.append(<span class="jxr_string">"              "</span>);
<a class="jxr_linenumber" name="L637" href="#L637">637</a>     _builder.append(<span class="jxr_string">"End of "</span>);
<a class="jxr_linenumber" name="L638" href="#L638">638</a>     String _name_2 = classifier.getName();
<a class="jxr_linenumber" name="L639" href="#L639">639</a>     _builder.append(_name_2, <span class="jxr_string">"              "</span>);
<a class="jxr_linenumber" name="L640" href="#L640">640</a>     _builder.append(<span class="jxr_string">" class body"</span>);
<a class="jxr_linenumber" name="L641" href="#L641">641</a>     _builder.newLineIfNotEmpty();
<a class="jxr_linenumber" name="L642" href="#L642">642</a>     _builder.append(<span class="jxr_string">" "</span>);
<a class="jxr_linenumber" name="L643" href="#L643">643</a>     _builder.append(<span class="jxr_string">"************************************************************/"</span>);
<a class="jxr_linenumber" name="L644" href="#L644">644</a>     _builder.newLine();
<a class="jxr_linenumber" name="L645" href="#L645">645</a>     <strong class="jxr_keyword">return</strong> _builder;
<a class="jxr_linenumber" name="L646" href="#L646">646</a>   }
<a class="jxr_linenumber" name="L647" href="#L647">647</a> }
</pre>
<hr/>
<div id="footer">Copyright &#169; 2016 <a href="https://www.eclipse.org/">Eclipse foundation</a>. All rights reserved.</div>
</body>
</html>
